#include "pqMyDisplayPanelImplementation.h"

#include <QPushButton>

#include "pqDataRepresentation.h"
#include <pqDisplayPanel.h>
#include "pqPipelineSource.h"
#include <pqRepresentation.h>
#include <vtkSMProxy.h>

class pqMyDisplayPanelWidget
	: public pqDisplayPanel
{
public:
	pqMyDisplayPanelWidget(pqRepresentation* repr, QWidget* p)
		: pqDisplayPanel(repr, p)
	{
		new QPushButton("TEST", p);
	}
	virtual ~pqMyDisplayPanelWidget() { }
};

pqMyDisplayPanelImplementation::pqMyDisplayPanelImplementation(QObject* p)
	: QObject(p)
{
}

pqMyDisplayPanelImplementation::~pqMyDisplayPanelImplementation()
{
}

bool pqMyDisplayPanelImplementation::canCreatePanel(pqRepresentation* proxy) const
{
    if (!proxy || !proxy->getProxy()) 
    {
		return false;
	}

	QString type = qobject_cast<pqDataRepresentation*>(proxy)->getInput()->getProxy()->GetXMLName();
	if (type == "P3DReader") 
	{
		return true;
	}

	return false;
}

pqDisplayPanel* pqMyDisplayPanelImplementation::createPanel(pqRepresentation* proxy, QWidget* p)
{
    if (canCreatePanel(proxy))
    {
	return new pqMyDisplayPanelWidget(proxy, p);
    }

    return NULL;
}

